package com.damiano.flashlight;

import android.content.Context;
import android.hardware.camera2.CameraAccessException;
import android.hardware.camera2.CameraManager;

// Import corretti di MIT App Inventor
import com.google.appinventor.components.annotations.SimpleFunction;
import com.google.appinventor.components.annotations.SimpleProperty;
import com.google.appinventor.components.runtime.AndroidNonvisibleComponent;
import com.google.appinventor.components.runtime.ComponentContainer;
import com.google.appinventor.components.runtime.Form;

public class Flashlight extends AndroidNonvisibleComponent {

    private CameraManager cameraManager;
    private String cameraId;
    private final Context context;

    public Flashlight(ComponentContainer container) {
        super(container.$form());
        context = container.$context();
        cameraManager = (CameraManager) context.getSystemService(Context.CAMERA_SERVICE);
        try {
            cameraId = cameraManager.getCameraIdList()[0];
        } catch (CameraAccessException e) {
            e.printStackTrace();
        }
    }

    @SimpleFunction(description = "Turns the flashlight on.")
    public void TurnOnFlash() {
        try {
            if (cameraId != null) {
                cameraManager.setTorchMode(cameraId, true);
            }
        } catch (CameraAccessException e) {
            e.printStackTrace();
        }
    }

    @SimpleFunction(description = "Turns the flashlight off.")
    public void TurnOffFlash() {
        try {
            if (cameraId != null) {
                cameraManager.setTorchMode(cameraId, false);
            }
        } catch (CameraAccessException e) {
            e.printStackTrace();
        }
    }
}